﻿using System.Data.Entity;
using HowDoI.DBInitializers.Domain;
using System.Collections.Generic;

namespace HowDoI.DBInitializers.DataAccess
{
    public class BlogContext : DbContext
    {
        public DbSet<Blog> Blogs { get; set; }
        public DbSet<Post> Posts { get; set; }
        public DbSet<Comment> Comments { get; set; }
    }

    public class BlogContextInitializer : System.Data.Entity.DropCreateDatabaseIfModelChanges<BlogContext>
    {

        protected override void Seed(BlogContext context)
        {
            //simple seed code
            //        var blog=new Blog
            //        {
            //            BloggerName = "Julie",
            //            Title = "My Code First Blog",
            //            DateCreated = System.DateTime.Now
            //        };
            //        context.Blogs.Add(blog);
            //        base.Seed(context);
            //    }
            //}

            //seeding code with related data, too
            new List<Blog>
            {
                new Blog { BloggerName = "Julie", Title = "My Code First Blog",
                DateCreated=System.DateTime.Now,
                Posts=new List<Post>
                {
                                new Post
                                {
                                    Title="ForeignKeyAttribute Annotation",
                                    DateCreated=new System.DateTime(2011,3,15), 
                                    Content="Mark navigation property with ForeignKey"
                                },
                                new Post
                                {
                                    Title="Working with the ChangeTracker",
                                    DateCreated=System.DateTime.Now, 
                                    Content="You can use db.Entry to get to state for a single entry or" +
                                    "db.ChangeTracker.Entries to work with all of the tracked entries."
                                }
                }
                },
                new Blog { BloggerName = "Ingemaar", Title = "My Life as a Blog",DateCreated=System.DateTime.Now.AddDays(1)},
                new Blog { BloggerName = "Sampson", Title = "Tweeting for Dogs", DateCreated=System.DateTime.Now.AddDays(2)}
            }.ForEach(b => context.Blogs.Add(b));
            base.Seed(context);
        }
    }
}
